#property copyright "IgorM"

extern double  StopLoss          = 300.0;       //  Stop Loss   ,  4-  30.0
extern double  TakeProfit        = 0.0;         //  Take Profit   ,    0.0
extern double  Lot               = 0.1;         //  /  
extern int     StopLossRevers    = 100.0;       //  Stop Loss   ,  4-  10.0
extern string  Comments          = "My_expert"; //   
extern int     Magic             = 12345;       //   
extern double  Slippage          = 30;          //        - 


int bar;                                        //     
int total_order;                                //          
int my_total_order;                             //           Magic
bool HaveBuyOrder;                              //       
bool HaveSellOrder;                             //       
string Curr_symb;                               //      

 
int init(){
   bar=Bars;
   Curr_symb = Symbol();
   Myorders();
return(0);
}


void Myorders(){
      int cnt;
      total_order = OrdersTotal();
      my_total_order = 0;
      HaveBuyOrder  = false;
      HaveSellOrder = false;
      for(cnt = total_order - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Curr_symb && OrderMagicNumber() == Magic) {
         if (OrderType() == OP_BUY)  {HaveBuyOrder = true;  my_total_order++;}
         if (OrderType() == OP_SELL) {HaveSellOrder = true; my_total_order++;}
      }
   }

}

//-------------------------------------------------------
//     Buy
//-------------------------------------------------------
int OpenBuyOrder() {
   int ticket=-1;
   double SL, TP, PR;
   PR=NormalizeDouble(Ask,Digits);
   if(StopLoss==0) SL=0;
     else{ SL=PR-StopLoss*Point; SL=NormalizeDouble(SL,Digits); }
   if(TakeProfit==0) TP=0;
      else{ TP=PR+TakeProfit*Point; TP=NormalizeDouble(TP,Digits); }
   ticket = OrderSend(Curr_symb,OP_BUY, Lot, PR, Slippage, SL, TP, Comments, Magic, 0, Blue);
   if (ticket > 0) {
      HaveBuyOrder = true;
      if (OrderSelect(ticket, SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice());
   }
   else Print("  ",  GetLastError(), "   BUY  ",MarketInfo(Curr_symb,MODE_ASK));
   return(0);
}

//-------------------------------------------------------
//     Sell
//-------------------------------------------------------
int OpenSellOrder() {
   int ticket=-1;
   double SL, TP, PR;
   PR=NormalizeDouble(Bid,Digits);
   if(StopLoss==0.0)SL=0.0;
     else{ SL=PR+StopLoss*Point; SL=NormalizeDouble(SL,Digits); }
  if(TakeProfit==0.0) TP=0.0;
   else{ TP=PR-TakeProfit*Point; TP=NormalizeDouble(TP,Digits); }
   ticket = OrderSend(Curr_symb, OP_SELL, Lot, PR, Slippage, SL, TP, Comments, Magic, 0, Red);
   if (ticket > 0) {
      HaveSellOrder = true;
      if (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))  Print("SELL order opened : ", OrderOpenPrice());
   }
   else Print("  ",  GetLastError(), "   SELL  ",MarketInfo(Curr_symb,MODE_ASK));
   return(0);
}

//-------------------------------------------------------
//      
//-------------------------------------------------------
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
   bool   fm;
   color  cl;
   double op, pa, pb, os, ot;
   string sy = OrderSymbol();
   int    dg = MarketInfo(sy, MODE_DIGITS), er, it;

   if (pp<=0) pp=OrderOpenPrice();
   if (sl<0 ) sl=OrderStopLoss();
   if (tp<0 ) tp=OrderTakeProfit();

   pp=NormalizeDouble(pp, dg);
   sl=NormalizeDouble(sl, dg);
   tp=NormalizeDouble(tp, dg);
   op=NormalizeDouble(OrderOpenPrice() , dg);
   os=NormalizeDouble(OrderStopLoss()  , dg);
   ot=NormalizeDouble(OrderTakeProfit(), dg);
   
   if (pp!=op || sl!=os || tp!=ot) {
      for (it=1; it<=2; it++) {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while (!IsTradeAllowed()) Sleep(2000);
         RefreshRates();
         fm = OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
         if (!fm) {
            er=GetLastError();
            pa=MarketInfo(sy, MODE_ASK);
            pb=MarketInfo(sy, MODE_BID);
           Print("Error(",er,") modifying order: ",er,", try ",it);
         }
      }
   }
}

//----------------------------------------------------------------------
//-----   ,     
//-----   ""  StopLoss = StopLossRevers
//----- ..   
//----------------------------------------------------------------------
int CheckOpenOrdersBuy(double sl) {
   int cnt;
   double pp;
   bool HaveOrder = false;
   for(cnt = total_order - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Curr_symb) {
         if (OrderMagicNumber() == Magic) {
            pp = OrderOpenPrice();
            sl = MathMax(MarketInfo(Curr_symb, MODE_STOPLEVEL), sl);
            if (OrderType() == OP_BUY && OrderSymbol() == Curr_symb && OrderMagicNumber() == Magic) {
                  HaveOrder = true;
                  if (OrderProfit() >= 0) {
//    
                  Print("  ,   :"); OrderPrint();
                  OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Violet);
               }
               else {
//     -
                  Print("  ,  :"); OrderPrint();
                  if (OrderStopLoss() != 0) {
//  -    ...
                     if (Bid - sl * Point > OrderStopLoss()) {
// ...   -     
                        ModifyOrder(pp, Bid - sl * Point, OrderTakeProfit(), Yellow);
                     }
                  }
                  else {
// -     - 
                     ModifyOrder(pp, Bid - sl * Point, OrderTakeProfit(), Yellow);
                  }
               }
            }
         }
      }
   }
   HaveBuyOrder = HaveOrder;
return(0);
}
//----------------------------------------------------------------------
//-----   ,     ,
//-----   ""  StopLoss = StopLossRevers
//----- ..   
//----------------------------------------------------------------------
int CheckOpenOrdersSell(double sl) {
   int cnt;
   double pp;
   bool HaveOrder = false;
   for(cnt = total_order - 1; cnt >= 0; cnt--) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Curr_symb) {
         if (OrderMagicNumber() == Magic) {
            pp = OrderOpenPrice();
            sl = MathMax(MarketInfo(Curr_symb, MODE_STOPLEVEL), sl);
            if (OrderType() == OP_SELL && OrderSymbol() == Curr_symb && OrderMagicNumber() == Magic) {
               HaveOrder = true;
               if (OrderProfit() >= 0) {
//    
                  Print("  ,   :"); OrderPrint();
                  OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Violet);
               }
               else {
//     -
                  Print("  ,  :"); OrderPrint();
                  if (OrderStopLoss() != 0) {
//  -    ...
                     if (Ask + sl * Point < OrderStopLoss()) {
// ...   -     
                        ModifyOrder(pp, Ask + sl * Point, OrderTakeProfit(), Yellow);
                     }
                  }
                  else {
// -     - 
                     ModifyOrder(pp, Ask + sl * Point, OrderTakeProfit(), Yellow);
                  }
               }
            }
         }
      }
   }
   HaveSellOrder = HaveOrder;
return(0);
}

//--------------------------------------------------------------------------------------
//    
//--------------------------------------------------------------------------------------

// HaveSellOrder - ,       Sell 
// HaveSellOrder == true  -        Sell
// HaveSellOrder == false - ,       Sell

// HaveBuyOrder - ,       Buy
// HaveBuyOrder == true  -        Buy
// HaveBuyOrder == false - ,       Buy

// OpenSellOrder() -     Sell   
//                     StopLoss, TakeProfit, Lot, Comments, Magic, Slippage - .
// OpenBuyOrder()  -     Buy   
//                     StopLoss, TakeProfit, Lot, Comments, Magic, Slippage - .

//CheckOpenOrdersSell(StopLossRevers) -       Sell,  
//                                       ,    ,     ,
//                                        StopLossRevers     
//                                     Stop Loss        
//                                     Stop Loss   ,        
//                                        ,     Stop Loss
//CheckOpenOrdersBuy(StopLossRevers) -       Buy,  
//                                       ,    ,     ,
//                                        StopLossRevers     
//                                     Stop Loss        
//                                     Stop Loss   ,        
//                                        ,     Stop Loss 




int start(){
   Myorders();       //      my_total_order
                     //     HaveSellOrder  HaveBuyOrder
//---------------------------------------------------------------------------------------------------
//    ,    /     
// ..   "func1" == "func2"    /  
//---------------------------------------------------------------------------------------------------
   if (!HaveSellOrder && "func1" == "func2") OpenSellOrder();      //     Sell
   if (!HaveBuyOrder  && "func1" == "func2") OpenBuyOrder();       //     Buy
   
   if (HaveSellOrder && "func1" == "func2") CheckOpenOrdersSell(StopLossRevers);  //     Sell
   if (HaveBuyOrder  && "func1" == "func2") CheckOpenOrdersBuy(StopLossRevers);   //     Buy
   

//     /     
   
int CountedBar = Bars;
if (CountedBar > bar) {
    bar=CountedBar;
//    /     
}
   
return(0);
}